interface WatchOptions {
    debounce?: number | boolean | false;
}
declare type Rule = (value: any, values: any) => Promise<any> | any;
interface FieldConfig {
    name: string;
    defaultValue?: any;
    rules?: Rule;
}
interface FormOptions {
    fields?: FieldConfig[];
    relatives?: {
        [key: string]: (values: any, errors: any) => any;
    };
}
export default function createForm(formOptions?: FormOptions): {
    getValue: any;
    getValues: any;
    setValue: any;
    setValues: any;
    watchValues: any;
    watchValue: any;
    getError: any;
    getErrors: any;
    setError: any;
    setErrors: any;
    watchErrors: any;
    watchError: any;
    getFields: () => any;
    setFields: (nextFields: any) => void;
    removeField: (fieldName: any) => void;
    addField: (field: any) => () => void;
    getRelative: (key: any) => any;
    getRelatives: () => any;
    setRelatives: (configs: any) => void;
    removeRelative: (name: any) => void;
    addRelative: (name: any, compute: any) => () => void;
    watchRelatives: (listener: any, options?: WatchOptions) => () => any;
    watchRelative: (key: any, listener: any, options?: WatchOptions) => () => any;
    watch: (listener: any) => () => void;
    validate: (filedKeys: any) => Promise<boolean>;
    reset: () => void;
};
export {};
